All of lore.kernel.org
 help / color / mirror / Atom feed
From: "Darrick J. Wong" <djwong@kernel.org>
To: djwong@kernel.org, guaneryu@gmail.com
Cc: linux-xfs@vger.kernel.org, fstests@vger.kernel.org, guan@eryu.me
Subject: [PATCH 2/2] xfs: test the xfs_db ls command
Date: Mon, 22 Mar 2021 21:20:29 -0700	[thread overview]
Message-ID: <161647322983.3430916.9402200604814364098.stgit@magnolia> (raw)
In-Reply-To: <161647321880.3430916.13415014495565709258.stgit@magnolia>

From: Darrick J. Wong <djwong@kernel.org>

Make sure that the xfs_db ls command works the way the author thinks it
does.

Signed-off-by: Darrick J. Wong <djwong@kernel.org>
---
 tests/xfs/918     |  109 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/xfs/918.out |   27 +++++++++++++
 tests/xfs/group   |    1 
 3 files changed, 137 insertions(+)
 create mode 100755 tests/xfs/918
 create mode 100644 tests/xfs/918.out


diff --git a/tests/xfs/918 b/tests/xfs/918
new file mode 100755
index 00000000..7211df92
--- /dev/null
+++ b/tests/xfs/918
@@ -0,0 +1,109 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0-or-later
+# Copyright (c) 2021 Oracle.  All Rights Reserved.
+#
+# FS QA Test No. 918
+#
+# Make sure the xfs_db ls command works the way the author thinks it does.
+# This means that we can list the current directory, list an arbitrary path,
+# and we can't list things that aren't directories.
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1    # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs xfs
+_require_xfs_db_command "path"
+_require_xfs_db_command "ls"
+_require_scratch
+
+echo "Format filesystem and populate"
+_scratch_mkfs > $seqres.full
+_scratch_mount >> $seqres.full
+
+$XFS_INFO_PROG $SCRATCH_MNT | grep -q ftype=1 || \
+	_notrun "filesystem does not support ftype"
+
+filter_ls() {
+	awk '
+BEGIN { cookie = 0; }
+{
+	if (cookie == 0)
+		cookie = $1;
+	printf("+%d %s %s %s %s %s\n", $1 - cookie, $2, $3, $4, $5, $6);
+	cookie = $1;
+}' | \
+	sed	-e "s/ $root_ino directory / root directory /g" \
+		-e "s/ $a_ino directory / a_ino directory /g" \
+		-e "s/ $b_ino directory / b_ino directory /g" \
+		-e "s/ $c_ino regular / c_ino regular /g" \
+		-e "s/ $d_ino symlink / d_ino symlink /g" \
+		-e "s/ $e_ino blkdev / e_ino blkdev /g" \
+		-e "s/ $f_ino chardev / f_ino chardev /g" \
+		-e "s/ $g_ino fifo / g_ino fifo /g" \
+		-e "s/ $big0_ino regular / big0_ino regular /g" \
+		-e "s/ $big1_ino regular / big1_ino regular /g" \
+		-e "s/ $h_ino regular / g_ino regular /g"
+}
+
+mkdir $SCRATCH_MNT/a
+mkdir $SCRATCH_MNT/a/b
+$XFS_IO_PROG -f -c 'pwrite 0 61' $SCRATCH_MNT/a/c >> $seqres.full
+ln -s -f b $SCRATCH_MNT/a/d
+mknod $SCRATCH_MNT/a/e b 0 0
+mknod $SCRATCH_MNT/a/f c 0 0
+mknod $SCRATCH_MNT/a/g p
+touch $SCRATCH_MNT/a/averylongnameforadirectorysothatwecanpushthecookieforward
+touch $SCRATCH_MNT/a/andmakethefirstcolumnlookmoreinterestingtopeoplelolwtfbbq
+touch $SCRATCH_MNT/a/h
+
+root_ino=$(stat -c '%i' $SCRATCH_MNT)
+a_ino=$(stat -c '%i' $SCRATCH_MNT/a)
+b_ino=$(stat -c '%i' $SCRATCH_MNT/a/b)
+c_ino=$(stat -c '%i' $SCRATCH_MNT/a/c)
+d_ino=$(stat -c '%i' $SCRATCH_MNT/a/d)
+e_ino=$(stat -c '%i' $SCRATCH_MNT/a/e)
+f_ino=$(stat -c '%i' $SCRATCH_MNT/a/f)
+g_ino=$(stat -c '%i' $SCRATCH_MNT/a/g)
+big0_ino=$(stat -c '%i' $SCRATCH_MNT/a/avery*)
+big1_ino=$(stat -c '%i' $SCRATCH_MNT/a/andma*)
+h_ino=$(stat -c '%i' $SCRATCH_MNT/a/h)
+
+_scratch_unmount
+
+echo "Manually navigate to root dir then list"
+_scratch_xfs_db -c 'sb 0' -c 'addr rootino' -c ls > /tmp/fuck0
+cat /tmp/fuck0 | filter_ls > /tmp/fuck1
+_scratch_xfs_db -c 'sb 0' -c 'addr rootino' -c ls | filter_ls
+
+echo "Use path to navigate to root dir then list"
+_scratch_xfs_db -c 'path /' -c ls | filter_ls
+
+echo "Use path to navigate to /a then list"
+_scratch_xfs_db -c 'path /a' -c ls | filter_ls
+
+echo "Use path to navigate to /a/b then list"
+_scratch_xfs_db -c 'path /a/b' -c ls | filter_ls
+
+echo "Use path to navigate to /a/c (non-dir) then list"
+_scratch_xfs_db -c 'path /a/c' -c ls
+
+# success, all done
+status=0
+exit
diff --git a/tests/xfs/918.out b/tests/xfs/918.out
new file mode 100644
index 00000000..62d43c8a
--- /dev/null
+++ b/tests/xfs/918.out
@@ -0,0 +1,27 @@
+QA output created by 918
+Format filesystem and populate
+Manually navigate to root dir then list
++0 root directory 0x0000002e 1 .
++2 root directory 0x0000172e 2 ..
++2 a_ino directory 0x00000061 1 a
+Use path to navigate to root dir then list
++0 root directory 0x0000002e 1 .
++2 root directory 0x0000172e 2 ..
++2 a_ino directory 0x00000061 1 a
+Use path to navigate to /a then list
++0 a_ino directory 0x0000002e 1 .
++2 root directory 0x0000172e 2 ..
++2 b_ino directory 0x00000062 1 b
++2 c_ino regular 0x00000063 1 c
++2 d_ino symlink 0x00000064 1 d
++2 e_ino blkdev 0x00000065 1 e
++2 f_ino chardev 0x00000066 1 f
++2 g_ino fifo 0x00000067 1 g
++2 big0_ino regular 0xc7457cba 57 averylongnameforadirectorysothatwecanpushthecookieforward
++9 big1_ino regular 0xeefd9237 57 andmakethefirstcolumnlookmoreinterestingtopeoplelolwtfbbq
++9 g_ino regular 0x00000068 1 h
+Use path to navigate to /a/b then list
++0 b_ino directory 0x0000002e 1 .
++2 a_ino directory 0x0000172e 2 ..
+Use path to navigate to /a/c (non-dir) then list
+Not a directory
diff --git a/tests/xfs/group b/tests/xfs/group
index daa56787..45628739 100644
--- a/tests/xfs/group
+++ b/tests/xfs/group
@@ -518,3 +518,4 @@
 759 auto quick rw realtime
 760 auto quick rw realtime collapse insert unshare zero prealloc
 917 auto quick db
+918 auto quick db


  parent reply	other threads:[~2021-03-23  4:21 UTC|newest]

Thread overview: 12+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2021-03-23  4:20 [PATCHSET 0/2] fstests: test xfs_db directory navigation Darrick J. Wong
2021-03-23  4:20 ` [PATCH 1/2] xfs: test the xfs_db path command Darrick J. Wong
2021-03-25  9:33   ` Chandan Babu R
2021-03-25 16:33     ` Darrick J. Wong
2021-03-26  3:31       ` Chandan Babu R
2021-03-23  4:20 ` Darrick J. Wong [this message]
2021-03-25 10:08   ` [PATCH 2/2] xfs: test the xfs_db ls command Chandan Babu R
2021-03-25 16:35     ` Darrick J. Wong
2021-03-25 16:36   ` [PATCH v1.1 " Darrick J. Wong
2021-03-26  3:32     ` Chandan Babu R
  -- strict thread matches above, loose matches on Subject: below --
2020-10-27 19:03 [PATCH RFC 0/2] xfs_db: add minimal directory navigation Darrick J. Wong
2020-10-27 19:03 ` [PATCH 2/2] xfs: test the xfs_db ls command Darrick J. Wong
2020-10-29 20:24   ` Darrick J. Wong

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=161647322983.3430916.9402200604814364098.stgit@magnolia \
    --to=djwong@kernel.org \
    --cc=fstests@vger.kernel.org \
    --cc=guan@eryu.me \
    --cc=guaneryu@gmail.com \
    --cc=linux-xfs@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.